/*	OS error	*/

#include	"applicationGlobals.h"

#define	rOSErrAlert	1600

#ifdef TARGET_API_MAC_CARBON
extern void setArrowCursor();
#endif

/********************************************************
	showOSError(fileSpec.name,  errorFileManager, iErr, kFatal);
	showOSError(gPrefFSSpec.name,  errorResourceManager, ResError(), kFatal);
	showOSError(nil,  errorMemoryManager, MemError(), kFatal);

#define	errorFileManager		1600
#define	errorResourceManager	1601
#define	errorMemoryManager	1602

*********************************************************/

void		showOSError(Str255 param1,  short rID, OSErr error, Boolean isFatal)
{
#ifndef TARGET_API_MAC_CARBON
	OSErr	iErr = noErr;
#endif
	short	itemHit;
	Str255	param2, param3, theString;
	short	index;
	long		theNum;
        
	if(error == noErr)
		return;

	//get comment to display on the alert
	GetIndString(param2, rID, 1);		//"File System Error"
	GetIndString(param3, rID, 2);		//"Unknown reason"

	//get error comment from error number
	index = 3;
	do
	{
		GetIndString(theString, rID, index);
		StringToNum(theString,&theNum);
		if(theNum == error)
		{
			GetIndString(param3, rID, index+1);		//"No such volume"
			break;
		}
		index ++;
		index ++;			
	}while(theString[0] != 0);

#ifdef TARGET_API_MAC_CARBON
        setArrowCursor();
#else
	SetCursor(&qd.arrow);
#endif
	ParamText(param1, param2, param3, nil);
	itemHit = Alert(rOSErrAlert, nil);
	
	//fatal error
	if(isFatal)
		ExitToShell();
}
